$( document ).ready(function() {

  queue = new Queue();

    $.ajax({
      // url:      './api/index.php',
      url:      './services.json',
      // type:     'POST',
      type:     'GET',
      dataType: 'json',
      // data: {
      //   end     : 'modtable',
      //   action  : 'getstatus'
      // }
    })
    .done(function(response) {
      for (var service in response) {
        for (var module in response[service]) {
          // response[service][module][0] : enable
          // response[service][module][1] : order index
          if (response[service][module][0]) {
            var moduleBtn = $('[data-module="' + service + '.' + module + '"]');
            var card = moduleBtn.parents('div.card');
            moduleBtn.attr('data-enabled', true).html('Disable Module');
            moduleBtn.parents('footer.card-footer').removeAttr('style');
            card.find('.card-content').removeAttr('style');
            card.find('header.card-header > .card-header-title > i').removeClass('icon-check-empty').addClass('icon-check');
            var cardIcon = card.find('header.card-header a.card-header-icon i');
            cardIcon.removeClass('icon-angle-down').addClass('icon-angle-up');
            cardIcon.attr('aria-hidden', 'false');
            queue.addModule(service, module, response[service][module][1]);
          }
        }
      }
      // console.log('#list', queue.list)
      handleQueue();
    })
    .fail(function() {
      console.log("error");
    })
    .always(function() {
      console.log("complete");
    });


    // Slide Toggle on Click
    $('[aria-label="more-options"]').click(function(event) {
      var ariaHidden = $(this).find('i[aria-hidden]');
      var ariaHiddenAttr = ariaHidden.attr('aria-hidden') === 'true' ? true : false;
      var card = $(this).parents('.card');
      card.find('.card-content').slideToggle();
      card.find('.card-footer').slideToggle();

      if (ariaHiddenAttr) {
        ariaHidden.removeClass('icon-angle-down').addClass('icon-angle-up');
      } else {
        ariaHidden.removeClass('icon-angle-up').addClass('icon-angle-down');
      }
      ariaHidden.attr('aria-hidden', !ariaHiddenAttr);
      // var $(this).find('i[aria-hidden]')
      event.preventDefault();
    });


    // Enable / Disable Module
    $('[data-module]').click(function(event) {
      var btn = $(this);
      var enabled = btn.attr('data-enabled') === 'true' ? true : false;
      var dataAction = enabled ? 'disable' : 'enable';
      btn.html('Wait...');
      $.ajax({
        method  : 'POST',
        // url     : './api/index.php',
        url     : './api',
        dataType: 'json',
        data  : {
          end     : 'module',
          module  : btn.data('module'),
          action  : dataAction
        }
      }).done(function(response) {
        if (response.status) {
          var icon = btn.parents('.card').find('header.card-header > .card-header-title > i');
          btn.attr('data-enabled', !enabled);
          if (enabled) {
            btn.html('Enable Module');
            icon.removeClass('icon-check').addClass('icon-check-empty');
          } else {
            btn.html('Disable Module');
            icon.removeClass('icon-check-empty').addClass('icon-check');
          }
        }
      });
      event.preventDefault();
    });


    $('#operation-queue').on('click', 'a[href="#sort"]', function(event) {
      var index = $(this).data('index');
      queue.swap(index);
      handleQueue();
      event.preventDefault();
    });


    // Redraw Operation Queue
    function handleQueue() {
      var queueBox = $('#operation-queue');
      queueBox.html('');
      for (var item in queue.list) {
        console.log(item);
        if (item == 1)
          queueBox.append('<div class="tags has-addons"><span class="tag is-info">' + queue.list[item][0] + '</span><span class="tag is-success">' + queue.list[item][1] + '</span></div>');
        else
          queueBox.append('<div class="tags has-addons"><span class="tag is-info">' + queue.list[item][0] + '</span><span class="tag is-success">' + queue.list[item][1] + '</span><a href="#sort" data-index="' + item + '" class="tag is-light"><i class="icon-angle-up"></i></a></div>');
      }
    }


});

function Queue() {
  // this.queue = {};
  this.list = {};
}

Queue.prototype.addModule = function(service, module, index) {
  this.list[index] = [service, module];
  // if (this.queue[service] == undefined) {
    // this.queue[service] = {};
  // }
  // if (this.queue[service][module] == undefined) {
  //   this.queue[service][module] = index;
  // }
}

Queue.prototype.swap = function(index) {
  var temp = [this.list[index][0], this.list[index][1]];
  this.list[index] = [this.list[index-1][0], this.list[index-1][1]];
  this.list[index-1] = [temp[0], temp[1]];
}




// end of file
